﻿//TCP Client/Server 
//
// Simon Carter (s1cart3r@gmail.com)
//
//Redistribution and use in source and binary forms are permitted
//provided that the above copyright notice and this paragraph are
//duplicated in all such forms and that any documentation,
//advertising materials, and other materials related to such
//distribution and use acknowledge that the software was developed
//by techcoil.com and Simon Carter.  The name of the
//techcoil.com and Simon Carter may not be used to endorse or promote products derived
//from this software without specific prior written permission.
//THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
//IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
//WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//change history
// version 1.4 - Initially included in source code
//

using System;
using System.Text;

namespace TCPMessageServer.Utilities
{
    internal static class Utils
    {
        private const string AVAILABLE_CHARACTERS = "ABCDEFGHIJKLMNOPQRSTUVWQYZ0123456789abcdefghijklmnopqrstuvwxyz";
        private static Random _random;

        /// <summary>
        /// Creates a random string
        /// </summary>
        /// <param name="length">Length of string to create</param>
        /// <returns>Random string containing A-Z, a-z, 0-9</returns>
        internal static string RandomString(int length)
        {
            string Result = String.Empty;

            if (_random == null)
                _random = new Random(DateTime.Now.Hour + DateTime.Now.Minute + DateTime.Now.Second + DateTime.Now.Day);

            while (Result.Length < length)
            {
                Result += AVAILABLE_CHARACTERS.Substring(_random.Next(0, 62), 1);
            }

            return (Result);
        }

        /// <summary>
        /// Creates a random number
        /// </summary>
        /// <param name="min">Minimum Value for random number</param>
        /// <param name="max">Maximum value for random number</param>
        /// <returns>Random number between min and max</returns>
        internal static int RandomNumber(int min, int max)
        {
            if (_random == null)
                _random = new Random(DateTime.Now.Hour + DateTime.Now.Minute + DateTime.Now.Second + DateTime.Now.Day);

            return (_random.Next(min, max));
        }
    }
}
